PS6/Informatique/MCA/MCA/urls.py
from django.contrib import admin
from django.urls import include, path

from . import views

urlpatterns = [
    path('', views.index, name='index'),
    path('chargeur/', include('chargeur.urls')),
    path('admin/', admin.site.urls),
]

PS6/Informatique/MCA/chargeur/urls.py
from django.urls import path

from . import views

app_name = 'chargeur'
urlpatterns = [
    #//ex: /chargeur/
    path('', views.index, name='index'),
    path('<int:setting_id>', views.index_load, name='index_load'),
    path('load', views.load, name='load'),
    path('chain/', views.chain, name='chain'),
    path('chain/<int:chain_id>/', views.chain_detail, name='chain_detail'),
    path('chain/add/', views.add_chain, name='add_chain'),
    path('stats/', views.stats, name='stats'),
    path('error/', views.error, name='error'),
    path('error/<int:error_id>/', views.error_detail, name='error_detail'),
    path('about/', views.about, name ='about')
]

PS6/Informatique/MCA/chargeur/models.py
from django.db import models
from django.utils.translation import gettext_lazy as _
from django.utils import timezone
from django.forms import ModelForm

# Create your models here.
class Chain(models.Model):
    chain_name = models.CharField(max_length=100, unique=True)
    edit_date = models.DateField(auto_now=True)
    distance = models.FloatField()
    length = models.FloatField()
    diameter = models.FloatField()
    note = models.CharField(max_length=300, blank=True, default='')
    CAO = models.FileField(upload_to='chains/CAO', blank='True', default='')
    schematic = models.FileField(upload_to='chains/Schematic', blank=True, default='')

    def __str__(self):
        return self.chain_name

class Setting(models.Model):
    setting_name = models.CharField(max_length=200, unique=True)
    chain = models.ForeignKey(Chain, on_delete=models.CASCADE)
    tube_length = models.FloatField()
    tube_width = models.FloatField()

    def __str__(self):
        return self.setting_name

class Error(models.Model):
    class Alert_Type(models.TextChoices):
        WARNING = '1', _('Warning')
        LOW = '2', _('Low')
        MEDIUM = '3', _('Medium')
        HIGH = '4', _('High')
        CRITICAL = '5', _('Critical')

    error_name = models.CharField(max_length=100)
    error_description = models.CharField(max_length=300)
    alert_type = models.CharField(max_length=1, choices=Alert_Type.choices, default=Alert_Type.WARNING)
    timestamp = models.DateTimeField(default=timezone.now)
    ack = models.BooleanField(default=False)

PS6/Informatique/MCA/chargeur/forms.py
from django.forms import ModelForm, Textarea
from django.utils.translation import gettext_lazy as _
from .models import Chain, Setting

class SettingForm(ModelForm):
    class Meta:
        model = Setting
        fields = ['setting_name','tube_length','tube_width','chain']

class ChainForm(ModelForm):
    class Meta:
        model = Chain
        fields = ['chain_name','diameter','length','distance','note', 'CAO','schematic']
        labels = {
            'chain_name' : _('Name'),
            'diameter' : _('Tooth Diameter (in mm)'),
            'length' : _('Tooth Length (in mm)'),
            'distance' : _('Distance between teeth (in mm)'),
        }
        widget = {
            'note' : Textarea(attrs={'cols':80, 'rows':20}),
        }

PS6/Informatique/MCA/MCA/views.py
from django.shortcuts import redirect


def index(request):
    return redirect('/chargeur')

PS6/Informatique/MCA/chargeur/views.py
import chargeur
from django.shortcuts import get_object_or_404, render, redirect
from django.http import HttpResponseRedirect, Http404
from django.views.generic.edit import UpdateView
from django.urls import reverse
from django.views import generic
from django.utils import timezone
from django.http import HttpResponse
from django.contrib import messages

from .models import Chain, Setting, Error
from .forms import ChainForm, SettingForm

def index(request):
    active = 'index'
    form = SettingForm(request.POST or None)
    if request.method == 'POST':
        if 'save' in request.POST:
            if form.is_valid():
                form.save()
                messages.info(request, 'Setting has been successfully added')
                return redirect('chargeur:index')
    context = {
        'new' : True,
        'active' : active,
        'form': form
        }
    return render(request, 'chargeur/index.html', context)

def index_load(request, setting_id):
    active = 'index'
    setting = Setting.objects.get(pk=setting_id)
    form = SettingForm(request.POST or None, instance=setting)
    if form.is_valid():
        form.save()
        messages.info(request, 'Setting has been successfully updated')
        return redirect('chargeur:index')
    context = {
        'active' : active,
        'form': form
    }
    return render(request, 'chargeur/index.html', context)

def load(request):
    active = 'index'
    setting_list = Setting.objects.order_by('setting_name')
    if request.method == 'POST':
        setting_id =  request.POST['setting_id']
        return redirect('chargeur:index_load', setting_id)
    context = {
        'active' : active,
        'setting_list' : setting_list
    }
    return render(request, 'chargeur/index.html', context)

def chain(request):
    active = 'chains'
    chain_list = Chain.objects.order_by('chain_name')
    context = {
        'active' : active,
        'chain_list':chain_list
        }
    return render(request, 'chargeur/chain.html', context)

def chain_detail(request, chain_id):
    active = 'chains'
    chain_list = Chain.objects.order_by('chain_name')
    chain = Chain.objects.get(pk=chain_id)
    form = ChainForm(request.POST or None, instance=chain)
    if request.method == 'POST':
        if 'update' in request.POST:
            form = ChainForm(request.POST or None, request.FILES or None, instance=chain)
            if form.is_valid():
                form.save()
                messages.info(request, 'Chain has been successfully updated')
                return redirect('chargeur:chain_detail', chain_id)
        elif 'delete' in request.POST:
            chain.delete()
            return redirect('chargeur:chain')
    context = {
        'active' : active,
        'chain_list':chain_list,
        'chain': chain,
        'form': form,
    }
    return render(request, 'chargeur/chain.html', context)

def add_chain(request):
    active = 'chains'
    chain_list = Chain.objects.order_by('chain_name')
    form = ChainForm(request.POST or None, request.FILES)
    if form.is_valid():
        form.save()
        messages.info(request, 'Chain has been successfully added')
        return redirect('chargeur:add_chain')
    context = {
        'active' : active,
        'chain_list': chain_list,
        'form': form,
    }
    return render(request, 'chargeur/addChain.html', context)

def stats(request):
    active = 'stats'
    context = {
        'active' : active
    }
    return render(request, 'chargeur/stats.html', context)

def error(request):
    active = 'errors'
    warning_list = Error.objects.filter(alert_type='1').order_by("-timestamp")
    low_list = Error.objects.filter(alert_type='2').order_by("-timestamp")
    medium_list = Error.objects.filter(alert_type='3').order_by("-timestamp")
    high_list = Error.objects.filter(alert_type='4').order_by("-timestamp")
    critical_list = Error.objects.filter(alert_type='5').order_by("-timestamp")
    context = {
        'active' : active,
        'warning_list':warning_list,
        'low_list':low_list,
        'medium_list':medium_list,
        'high_list':high_list,
        'critical_list':critical_list,
        }
    return render(request, 'chargeur/error.html', context)

def error_detail(request, error_id):
    return HttpResponse("Error number %s page" % error_id)

def about(request):
    active = 'about'
    context = {
        'active' : active
    }
    return render(request, "chargeur/about.html", context)

PS6/Informatique/MCA/chargeur/templates/chargeur/about.html
{% include "chargeur/navbar.html" %}

PS6/Informatique/MCA/chargeur/templates/chargeur/addChain.html
{% include "chargeur/navbar.html" %}

<h2>Chains</h2>
<div class="container-fluid">
    <div class="row">
        <div class="col-2">
            {% if chain_list %}
                <ul>
                {% for chain in chain_list %}
                    <li><a href="{% url 'chargeur:chain_detail' chain.id %}">{{ chain }}</a></li>
                {% endfor %}
                </ul>
            {% else %}
                <p>No chains are available.</p>
            {% endif %}
            <form action="{% url 'chargeur:add_chain'%}">
                <button type="submit" class="btn btn-primary">Add new chain</button>
            </form>
        </div>
        <div class="col-10">
            <form action="" enctype="multipart/form-data" method="POST">
                {%csrf_token%}
                <table>
                    {{form.as_table }}
                </table>
                <input type="submit" class="btn btn-primary" value="Add">
            </form>
            {% if messages %}
            <ul class="messages">
                {% for message in messages %}
                <li{% if message.tags %} class="{{ message.tags }}"{% endif %} style='color:green'>{{ message }}</li>
                {% endfor %}
            </ul>
            {% endif %}
        </div>
    </div>
</div>

PS6/Informatique/MCA/chargeur/templates/chargeur/chain.html
{% include "chargeur/navbar.html" %}

<h2>Chains</h2>
<div class="container-fluid">
    <div class="row">
        <div class="col-2">
            {% if chain_list %}
                <ul>
                {% for chain in chain_list %}
                    <li><a href="{% url 'chargeur:chain_detail' chain.id %}">{{ chain }}</a></li>
                {% endfor %}
                </ul>
            {% else %}
                <p>No chains are available.</p>
            {% endif %}
            <form action="{% url 'chargeur:add_chain'%}">
                <button type="submit" class="btn btn-primary">Add new chain</button>
            </form>
                
        </div>
        <div class="col-10">
            {% include "chargeur/chainDetails.html" %}
        </div>
    </div>
</div>

PS6/Informatique/MCA/chargeur/templates/chargeur/chainDetails.html
{% if chain %}
    <form action="" enctype="multipart/form-data" method="POST">
        {%csrf_token%}
        <table>
            {{form.as_table }}
        </table>
        <input type="submit" name="update" class="btn btn-primary" value="Update">
        <input type="submit" name="delete" class="btn btn-danger" value="Delete">
    </form>
    {% if messages %}
    <ul class="messages">
        {% for message in messages %}
        <li{% if message.tags %} class="{{ message.tags }}"{% endif %} style='color:green'>{{ message }}</li>
        {% endfor %}
    </ul>
    {% endif %}
{% else %}

<h4>Select a chain to display, or add a new one</h4>

{% endif %}

PS6/Informatique/MCA/chargeur/templates/chargeur/error.html
{% include "chargeur/navbar.html" %}

<h2 align="center">Errors</h2>
<div class="container-fluid">
    <div class="row">
        <div class="col">
            <h4>Warning</h4>
            {% if warning_list %}
                <ul>
                {% for error in warning_list %}
                    <li>
                        <b>{{ error.timestamp|date:"D d/m/Y - H:i:s" }}</b><br>
                        {{error.error_name}}
                    </li>
                {% endfor %}
                </ul>
            {% else %}
                <p>No warnings available.</p>
            {% endif %}
        </div>
        <div class="col">
            <h4>Low</h4>
            {% if low_list %}
                <ul>
                {% for error in low_list %}
                    <li>
                        <b>{{ error.timestamp|date:"D d/m/Y - H:i:s" }}</b><br>
                        {{error.error_name}}
                    </li>
                {% endfor %}
                </ul>
            {% else %}
                <p>No error available.</p>
            {% endif %}
        </div>
        <div class="col">
            <h4>Medium</h4>
            {% if medium_list %}
                <ul>
                {% for error in medium_list %}
                    <li>
                        <b>{{ error.timestamp|date:"D d/m/Y - H:i:s" }}</b><br>
                        {{error.error_name}}
                    </li>
                {% endfor %}
                </ul>
            {% else %}
                <p>No error available.</p>
            {% endif %}
        </div>
        <div class="col">
            <h4>High</h4>
            {% if high_list %}
                <ul>
                {% for error in high_list %}
                    <li>
                        <b>{{ error.timestamp|date:"D d/m/Y - H:i:s" }}</b><br>
                        {{error.error_name}}
                    </li>
                {% endfor %}
                </ul>
            {% else %}
                <p>No error available.</p>
            {% endif %}
        </div>
        <div class="col">
            <h4>Critical</h4>
            {% if critical_list %}
                <ul>
                {% for error in critical_list%}
                    <li>
                        <b>{{ error.timestamp|date:"D d/m/Y - H:i:s" }}</b><br>
                        {{error.error_name}}
                    </li>
                {% endfor %}
                </ul>
            {% else %}
                <p>No error available.</p>
            {% endif %}
        </div>
    </div>
</div>

PS6/Informatique/MCA/chargeur/templates/chargeur/index.html
{% include "chargeur/navbar.html" %}
{% load bootstrap4 %}
{% bootstrap_css %}
{% bootstrap_javascript jquery='full' %}
<div class="container-fluid">
    <div class="row">
        <div class="col-8">
            <h2>Data</h2>
        </div>
        <div class="col-4">
            <h2>Status</h2>
            Automate is currently on : <br>
            Automate is not synchronized : <br>
            Automate cannot start loading : <br>
            
            <h2>Parameters</h2>
            {% if form %}
                <form action = "" method="POST">
                    {%csrf_token%}
                    <table>
                        {{form.as_table}}
                    </table>
                    <input type="submit" name="synchronize" class="btn btn-primary" value="Synchronize with parameters">
                    {% if new %}
                        <input type="submit" name="save" class="btn btn-primary" value="Save parameters">
                    {% else %}
                        <input type="submit" name="save" class="btn btn-primary" value="Update parameter">
                    {% endif %}
                </form>
                {% if new %} 
                <form action = "{% url 'chargeur:load' %}">
                    <input type="submit" class="btn btn-primary" value="Load parameter">
                </form>
                {% else %}
                <form action = "{% url 'chargeur:index' %}">
                    <input type="submit" class="btn btn-primary" value="New parameter">
                </form>
                {% endif %}
                {% if messages %}
                <ul class="messages">
                    {% for message in messages %}
                    <li{% if message.tags %} class="{{ message.tags }}"{% endif %} style='color:green'>{{ message }}</li>
                    {% endfor %}
                </ul>
                {% endif %}
            {% else %}
                <form action = "{% url 'chargeur:load'%}" method="POST">
                    {% csrf_token %}
                    <select name="setting_id" required>
                        {% for setting in setting_list %}
                        <option value="{{setting.pk}}">{{setting.setting_name}}</option>
                        {% endfor %}
                    </select>
                    <input type="submit" value="Load" class="btn btn-primary">
                </form>
            {% endif %}
        </div>
    </div>
</div>

PS6/Informatique/MCA/chargeur/templates/chargeur/navbar.html
{% load bootstrap4 %}
{% bootstrap_css %}
{% bootstrap_javascript jquery='full' %}
{% load static %}

<link rel="stylesheet" type="text/css" href="{% static 'polls/style.css' %}">

<nav class="navbar navbar-expand-md navbar-dark sticky-top bg-primary">
    <a class="navbar-brand" href="#">
        <img src="https://upload.wikimedia.org/wikipedia/de/thumb/f/f8/Wifag-Polytype_logo.svg/2000px-Wifag-Polytype_logo.svg.png"
        width="200"/>
    </a>
    <div class="collapse navbar-collapse" id="navBar">
        <ul class="navbar-nav mr-auto">
            <li class="nav-item {% if active == 'index' %} active {% endif %}">
                <a class="nav-link" href="{% url 'chargeur:index' %}">Home</a>
            </li>
            <li class="nav-item {% if active == 'stats' %} active {% endif %}">
                <a class="nav-link" href="{% url 'chargeur:stats' %}">Statistics</a>
            </li>
            <li class="nav-item {% if active == 'chains' %} active {% endif %}">
                <a class="nav-link" href="{% url 'chargeur:chain' %}">Chains</a>
            </li>
            <li class="nav-item {% if active == 'errors' %} active {% endif %}">
                <a class="nav-link" href="{% url 'chargeur:error' %}">Errors</a>
            </li>
            <li class="nav-item {% if active == 'about' %} active {% endif %}">
                <a class="nav-link" href="{% url 'chargeur:about' %}">About</a>
            </li>
        </ul>
        <span style="color:white">{% now "D d/m/Y H:i" %}</span>
        
    </div>
</nav>

PS6/Informatique/MCA/chargeur/templates/chargeur/stats.html
{% include "chargeur/navbar.html" %}